package net.knarcraft.blockhunt.arena;

/**
 * The arena properties that can be edited through a GUI
 */
public enum ArenaProperty {

    /**
     * The maximum amount of players that can play at once
     */
    MAX_PLAYERS,

    /**
     * The minimum amount of players required for the arena to start
     */
    MIN_PLAYERS,

    /**
     * The amount of players made into seekers when the arena starts
     */
    AMOUNT_SEEKERS_ON_START,

    /**
     * The amount of seconds the players are kept in the lobby to allow more players to join
     */
    TIME_IN_LOBBY_UNTIL_START,

    /**
     * The amount of seconds the hiders have to hide before the seekers start seeking
     */
    WAITING_TIME_SEEKER,

    /**
     * The amount of time until the game ends, unless all hiders are killed
     */
    GAME_TIME,

    /**
     * The amount of seconds until hiders are granted a sword to defend themselves with
     */
    TIME_UNTIL_HIDERS_SWORD,

    /**
     * The amount of tokens given to each hider if they win
     */
    HIDERS_TOKEN_WIN,

    /**
     * The amount of tokens given to each seeker if they win
     */
    SEEKERS_TOKEN_WIN,

    /**
     * The amount of tokens given to a seeker when they kill a hider
     */
    KILL_TOKENS,

    /**
     * The amount of seconds left on the arena timer when the types of hidden blocks are announced
     */
    BLOCK_ANNOUNCER_TIME

}
