package net.knarcraft.blockhunt.command;

import net.knarcraft.blockhunt.MemoryStorage;
import net.knarcraft.blockhunt.arena.Arena;
import net.knarcraft.blockhunt.arena.ArenaHandler;
import net.knarcraft.blockhunt.arena.ArenaLocations;
import net.knarcraft.blockhunt.config.MessageKey;
import net.knarcraft.blockhunt.manager.CommandManager;
import net.knarcraft.blockhunt.manager.MessageManager;
import org.bukkit.Location;
import org.bukkit.entity.Player;

public class SetWarpCommand extends DefaultCommand {

    @Override
    public boolean execute(Player player, String[] args) {
        if (player != null) {
            if (args.length <= 2) {
                MessageManager.sendFMessage(player, MessageKey.ERROR_NOT_ENOUGH_ARGUMENTS, "syntax-" +
                        CommandManager.setWarpCommand().usage());
            } else {
                String arenaName = args[2];
                String warpName = args[1];

                Arena arena = MemoryStorage.arenaMap.get(arenaName.toLowerCase());
                if (arena != null) {
                    ArenaLocations locations = arena.arenaLocations;
                    Location playerLocation = player.getLocation();
                    if (warpName.equalsIgnoreCase("lobby")) {
                        locations.setLobbyWarp(playerLocation);
                        save(arena);
                        MessageManager.sendFMessage(player, MessageKey.NORMAL_SET_WARP_WARP_SET, "warp-" + warpName);
                    } else if (warpName.equalsIgnoreCase("hiders")) {
                        locations.setHidersWarp(playerLocation);
                        save(arena);
                        MessageManager.sendFMessage(player, MessageKey.NORMAL_SET_WARP_WARP_SET, "warp-" + warpName);
                    } else if (warpName.equalsIgnoreCase("seekers")) {
                        locations.setSeekersWarp(playerLocation);
                        save(arena);
                        MessageManager.sendFMessage(player, MessageKey.NORMAL_SET_WARP_WARP_SET, "warp-" + warpName);
                    } else if (warpName.equalsIgnoreCase("spawn")) {
                        locations.setSpawnWarp(playerLocation);
                        save(arena);
                        MessageManager.sendFMessage(player, MessageKey.NORMAL_SET_WARP_WARP_SET, "warp-" + warpName);
                    } else {
                        MessageManager.sendFMessage(player, MessageKey.ERROR_SET_WARP_WARP_NOT_FOUND, "warp-" + warpName);
                    }
                } else {
                    MessageManager.sendFMessage(player, MessageKey.ERROR_NO_ARENA, "name-" + arenaName);
                }
            }
        } else {
            MessageManager.sendFMessage(null, MessageKey.ERROR_ONLY_IN_GAME);
        }
        return true;
    }

    public void save(Arena arena) {
        MemoryStorage.arenas.getFile().set(arena.arenaName, arena);
        MemoryStorage.arenas.save();
        ArenaHandler.loadArenas();
    }

}
